import { AfterContentInit, ChangeDetectorRef, OnDestroy, ViewContainerRef } from '@angular/core';
import { Subject } from 'rxjs';
import { INgxBindIOConfig } from '../interfaces/ngx-bind-io-config.interface';
import { INgxBindIODirective } from '../interfaces/ngx-bind-io-directive.interface';
import { NgxBindInputsService } from '../services/ngx-bind-inputs.service';
import { NgxBindIODebugService } from '../services/ngx-bind-io-debug.service';
export declare class BindInputsDirective implements Partial<INgxBindIODirective>, OnDestroy, AfterContentInit {
    private _ngxBindIOConfig;
    private _viewContainerRef;
    private _ngxBindInputsService;
    private _ngxBindIODebugService;
    private _ref;
    bindInputs?: INgxBindIOConfig;
    excludeInputs: string[] | string;
    includeInputs: string[] | string;
    component: any;
    parentComponent: any;
    inputs: {
        keys: string[];
        parentKeys: string[];
    };
    usedInputs: {
        [key: string]: string;
    };
    destroyed$: Subject<boolean>;
    constructor(_ngxBindIOConfig: INgxBindIOConfig, _viewContainerRef: ViewContainerRef, _ngxBindInputsService: NgxBindInputsService, _ngxBindIODebugService: NgxBindIODebugService, _ref: ChangeDetectorRef);
    ngAfterContentInit(): void;
    ngOnDestroy(): void;
    bindValue(key: string, value: any): void;
}
