import { AfterContentInit, ChangeDetectorRef, OnDestroy, ViewContainerRef } from '@angular/core';
import { Subject } from 'rxjs';
import { INgxBindIOConfig } from '../interfaces/ngx-bind-io-config.interface';
import { INgxBindIODirective } from '../interfaces/ngx-bind-io-directive.interface';
import { NgxBindIODebugService } from '../services/ngx-bind-io-debug.service';
import { NgxBindOutputsService } from '../services/ngx-bind-outputs.service';
export declare class BindOutputsDirective implements Partial<INgxBindIODirective>, OnDestroy, AfterContentInit {
    private _ngxBindIOConfig;
    private _viewContainerRef;
    private _ngxBindOutputsService;
    private _ngxBindIODebugService;
    private _ref;
    bindOutputs?: INgxBindIOConfig;
    excludeOutputs: string[] | string;
    includeOutputs: string[] | string;
    component: any;
    parentComponent: any;
    outputs: {
        keys: string[];
        parentKeys: string[];
    };
    usedOutputs: {
        [key: string]: string;
    };
    destroyed$: Subject<boolean>;
    constructor(_ngxBindIOConfig: INgxBindIOConfig, _viewContainerRef: ViewContainerRef, _ngxBindOutputsService: NgxBindOutputsService, _ngxBindIODebugService: NgxBindIODebugService, _ref: ChangeDetectorRef);
    ngAfterContentInit(): void;
    ngOnDestroy(): void;
}
