import { INgxBindIODirective } from '../interfaces/ngx-bind-io-directive.interface';
export declare class NgxBindInputsService {
    /**
     * BindInputs Directive
     */
    bindInputs(directive: Partial<INgxBindIODirective>): void;
    bindObservableInputs(directive: Partial<INgxBindIODirective>): void;
    /**
     * Inputs
     */
    checkKeyNameToInputBind(directive: Partial<INgxBindIODirective>, parentKey: string, key: string): boolean;
    checkInputToBind(directive: Partial<INgxBindIODirective>, parentKey: string, key: string): boolean;
    bindInput(directive: Partial<INgxBindIODirective>, parentKey: string, key: string): void;
    /**
     * Observable Inputs
     */
    checkKeyNameToObservableInputBind(directive: Partial<INgxBindIODirective>, parentKey: any, key: any): boolean;
    checkObservableInputToBind(directive: Partial<INgxBindIODirective>, parentKey: string, key: string): boolean;
    bindObservableInput(directive: Partial<INgxBindIODirective>, parentKey: string, key: string): void;
    /**
     * Utils
     */
    getInputs(directive: Partial<INgxBindIODirective>): {
        parentKeys: string[];
        keys: string[];
    };
}
